Imports System.IO

Public Class Rsspecan_IQ_Measurement_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub OpenButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenButton.Click

        If (saveFileDialog1.ShowDialog() = DialogResult.OK) Then

            textBox1.Text = saveFileDialog1.FileName
            If (File.Exists(textBox1.Text) = False) Then

                Using (File.Create(textBox1.Text))
                End Using
            End If
        End If

    End Sub

    Private Sub SaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Const numberOfValues As Integer = 4096
        Dim timeout As Integer = 15000    ' default value
        Dim returnedValues As Integer
        Dim resultI(numberOfValues) As Double
        Dim resultQ(numberOfValues) As Double
        Dim i As Integer

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenter(1, Convert.ToDouble(CenterFreq.Value))

            ' configure the reference level
            m_Instrument.ConfigureReferenceLevel(1, Convert.ToDouble(RefLevel.Value))

            ' select trace IQ measurement
            m_Instrument.ConfigureTraceIQDataAcquisition(1, True)

            ' configure the trace IQ
            m_Instrument.TraceIQSet(1, 32000000.0, 0, 0, 10000000.0, 0, numberOfValues)

            If (File.Exists(textBox1.Text) = False) Then

                If (saveFileDialog1.ShowDialog() = DialogResult.OK) Then
                    textBox1.Text = saveFileDialog1.FileName
                End If
            Else
                Return
            End If

            ' This function will start a measurement and read I/Q trace data results.
            m_Instrument.ReadTraceIQData(1, timeout, numberOfValues, returnedValues, resultI, resultQ)

            ' save data to file
            Using sw As New StreamWriter(textBox1.Text)

                sw.WriteLine("Real Parts (I)\tImaginary Parts(Q)")
                For i = 0 To numberOfValues Step 1

                    sw.WriteLine("{0}\t{1}", resultI(i), resultQ(i))
                Next
            End Using

            ' This function will start second measurement and read I/Q trace data results.
            m_Instrument.ReadTraceIQData(1, timeout, numberOfValues, returnedValues, resultI, resultQ)

            ' save data to file
            Using sw = File.AppendText(textBox1.Text)

                sw.WriteLine("Real Parts (I)\tImaginary Parts(Q)")
                For i = 0 To numberOfValues Step 1

                    sw.WriteLine("{0}\t{1}", resultI(i), resultQ(i))
                Next
            End Using


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
