Public Class Rsspecan_Spurious_Emissions_Example

    Private Sub Rsspecan_Spurious_Emissions_Example_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Detector.SelectedIndex = 4
    End Sub

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim i As Integer
        Dim returnedValues As Integer
        Dim frequency(50) As Double
        Dim level(50) As Double
        Dim deltaLimit(50) As Double

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), Convert.ToDouble(Span.Value))

            ' switch on the spurious emissions measurement
            m_Instrument.ConfigureSEState(True)

            ' configure the peak search for spurious emission measurement
            m_Instrument.ConfigureSEPeakSearch(1, Convert.ToDouble(Margin.Value), Convert.ToInt32(PeakNum.Value))

            ' configure the start and stop frequency for the specified range
            m_Instrument.ConfigureSESweepListStartStop(1, Convert.ToDouble(StartFreq.Value), Convert.ToDouble(StopFreq.Value))

            ' configure the resolution and video bandwidth values for the specified range
            m_Instrument.ConfigureSESweepListBandwidth(1, Convert.ToDouble(ResBand.Value), Convert.ToDouble(VidBand.Value))

            ' configure the detector value for the specified range
            m_Instrument.ConfigureSESweepListDetector(1, Detector.SelectedIndex)

            ' configure the reference level for the specified range
            m_Instrument.ConfigureSESweepListReferenceLevel(1, Convert.ToDouble(RefLevel.Value))

            ' start a new spurious measurement
            m_Instrument.InitiateSpurious(1, Convert.ToUInt32(Timeout.Value))

            ' search the peaks in spurious emissions data
            m_Instrument.SESearchPeak()

            ' read the spurious emissions peak list
            m_Instrument.ReadSEPeakList(Convert.ToInt32(PeakNum.Value), frequency, level, deltaLimit, returnedValues)

            PeakListTable.Rows.Clear()

            ' write peak list to table
            For i = 0 To (PeakNum.Value - 1) Step 1
                PeakListTable.Rows.Add()
                PeakListTable.Rows(i).Cells("Frequency").Value = frequency(i)
                PeakListTable.Rows(i).Cells("Level").Value = level(i)
                PeakListTable.Rows(i).Cells("DeltaLimit").Value = deltaLimit(i)
            Next i


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
