Imports System.IO
Imports System.Text

Public Class Rsspecan_Read_Trace_example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub MeasureAndSaveButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MeasureAndSaveButton.Click

        Dim m_Instrument As rsspecan
        Dim instr_modl As String
        Dim trace1(5000) As Double
        Dim actualCount As Integer
        Dim saveFileSW As StreamWriter = Nothing
        Dim statusData As New StringBuilder()

        Try
            If SaveMeasuredDataDialog.ShowDialog() = Windows.Forms.DialogResult.OK Then
                UseWaitCursor = True
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

                'initialize driver
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)

                'check for EMI test receiver
                instr_modl = m_Instrument.GetString(rsspecanProperties.RsAttrInstrumentModel, "")
                If (instr_modl.IndexOf("FMU") = 0) Then
                    m_Instrument.SetSANMode()
                End If

                'configure specan device: center frequency and span
                m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), Convert.ToDouble(Span.Value))

                'Set instrument to single sweep mode - continous mode is done
                'programmatically because this is the only way how to
                'synchronize measurement using *OPC
                m_Instrument.ConfigureSignalStatisticSweep(False)

                'Initiates a signal acquisition based on the present instrument configuration. 
                'It then waits for the acquisition to complete, and returns the trace as an 
                'array of amplitude values.
                m_Instrument.ReadYTrace(1, 1, 5000, 5000, actualCount, trace1)

                'open save file
                saveFileSW = New StreamWriter(SaveMeasuredDataDialog.FileName, False, Encoding.Default)

                'write data to file
                saveFileSW.Write("Trace data:")
                For Each data As Double In trace1
                    saveFileSW.Write(" " + data.ToString())
                Next

            End If
        Catch ex As Exception
            Dim message As String

            message = "Instrument Status Error: "
            message += ex.Message
            MessageBox.Show(message)

        Finally
            'close file if opened
            If Not (saveFileSW Is Nothing) Then
                saveFileSW.Close()
            End If

            UseWaitCursor = False
            System.Windows.Forms.Cursor.Current = Cursors.Default

        End Try
    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click

    End Sub
End Class
