Public Class Rsspeacan_Time_Domain_Power_Measurement_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim resultPeak, resultRMS, resultMean, resultSDev As Double

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' configure specan device: center frequency and span
            m_Instrument.ConfigureFrequencyCenterSpan(1, Convert.ToDouble(CenterFreq.Value), 0)

            ' configure time domain power measurement parameters
            m_Instrument.ConfigureTimeDomainPowerMeasurement(1, True, True, True, True, False, False, 0)

            ' switch on time domain power measurement
            m_Instrument.ConfigureTimeDomainPowerMeasurementState(1, True)

            ' do a sweep
            m_Instrument.Initiate(1, timeout)

            ' query peak power result
            m_Instrument.QueryTDomPowerResult(1, 0, 0, resultPeak)

            ' query RMS power result
            m_Instrument.QueryTDomPowerResult(1, 1, 0, resultRMS)

            ' query mean power result
            m_Instrument.QueryTDomPowerResult(1, 2, 0, resultMean)

            ' query SDEV power result
            m_Instrument.QueryTDomPowerResult(1, 3, 0, resultSDev)

            ' show channel power result in front panel textbox
            ResultTextBox.Text = "Peak" + vbTab + vbTab + resultPeak.ToString() + " dBm" + Environment.NewLine
            ResultTextBox.Text += "RMS" + vbTab + vbTab + resultRMS.ToString() + " dBm" + Environment.NewLine
            ResultTextBox.Text += "Mean" + vbTab + vbTab + resultMean.ToString() + " dBm" + Environment.NewLine
            ResultTextBox.Text += "Standard Deviation" + vbTab + resultSDev.ToString() + " dB"


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub
End Class
