Public Class Rsspecan_Limit_Line_Example

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click

        Dim m_Instrument As rsspecan = Nothing
        Dim timeout As Integer = 15000    ' default value
        Dim limitState As Integer
        Dim limitResult() As String = New String() {"PASS", "FAIL", "MARGIN"}
        Dim limitLinePosition() As Double = New Double(2) {}
        Dim limitLineFreq() As Double = New Double(2) {}

        Try
            UseWaitCursor = True
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            ' initialize driver
            If m_Instrument Is Nothing Then
                m_Instrument = New rsspecan(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked)
            ElseIf ResetDevice.Checked Then
                m_Instrument.reset()
            End If

            ' switch device display on/off
            m_Instrument.ConfigureDisplayUpdate(DisplayEnable.Checked)

            ' Set instrument to single sweep mode - continous mode is done
            ' programmatically because this is the only way how to
            ' synchronize measurement using *OPC
            m_Instrument.ConfigureSignalStatisticSweep(False)

            ' create limit line
            m_Instrument.CreateLimitLine(1, 1, "Limit", 0, "Comment", 1, True)

            ' configure limit line
            limitLineFreq(0) = Convert.ToDouble(StartFreq.Value)
            limitLineFreq(1) = Convert.ToDouble(StopFreq.Value)
            limitLinePosition(0) = Convert.ToDouble(Position.Value)
            limitLinePosition(1) = Convert.ToDouble(Position.Value)
            m_Instrument.DefineLimitLine(1, LimitLineType.SelectedIndex, 2, limitLineFreq, limitLinePosition)

            ' configure limit line
            m_Instrument.ConfigureLimitLine(1, LimitLineType.SelectedIndex, 0, 0, 0, 0, Convert.ToDouble(Margin.Value), -200.0)

            ' enable limit line
            m_Instrument.EnableLimitCheck(1, 1, LimitLineType.SelectedIndex, True, True)

            ' initiate measurement
            m_Instrument.Initiate(1, timeout)

            ' queries the result of the limit check
            m_Instrument.GetLimitCheckResult(1, 1, limitState)

            ' show limit check result
            ResultTextBox.Text = limitResult(limitState)


        Catch ex As System.Runtime.InteropServices.ExternalException

            Dim message As String

            message = "Instrument Status Error: " + ex.Message + Environment.NewLine
            message += "Instrument Error Code: " + ex.ErrorCode.ToString("X")
            MessageBox.Show(message)

        Finally

            System.Windows.Forms.Cursor.Current = Cursors.Default
            UseWaitCursor = False

        End Try

    End Sub

    Private Sub Rsspecan_Limit_Line_Example_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LimitLineType.SelectedIndex = 0
    End Sub
End Class
